{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

Author:       Franois PIETTE
Creation:     Mar 13, 2003
Description:
Version:      0.99 ALPHA CODE
EMail:        francois.piette@overbyte.be    francois.piette@rtfm.be
              http://www.overbyte.be
Support:      Unsupported code.
Legal issues: Copyright (C) 2003 by Franois PIETTE
              Rue de Grady 24, 4053 Embourg, Belgium. Fax: +32-4-365.74.56
              <francois.piette@overbyte.be>

              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any  damages arising from the use of this software.

              Permission is granted to anyone to use this software for any
              purpose, including commercial applications, and to alter it
              and redistribute it freely, subject to the following
              restrictions:

              1. The origin of this software must not be misrepresented,
                 you must not claim that you wrote the original software.
                 If you use this software in a product, an acknowledgment
                 in the product documentation would be appreciated but is
                 not required.

              2. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              3. This notice may not be removed or altered from any source
                 distribution.

              4. You must register this software by sending a picture postcard
                 to the author. Use a nice stamp and mention your name, street
                 address, EMail address and any comment you like to say.

History:


 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
unit OverbyteIcsFtpMultipartDownload1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IniFiles, StdCtrls, ExtCtrls, OverbyteIcsWndControl,
  OverbyteIcsMultipartFtpDownloader, OverbyteIcsMultiProgressBar;

type
  TMultipartFtpDownloadForm = class(TForm)
    ToolsPanel: TPanel;
    DisplayMemo: TMemo;
    MPFtp: TMultipartFtpDownloader;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    FtpServerEdit: TEdit;
    FtpPortEdit: TEdit;
    FtpDirEdit: TEdit;
    LocalFilePathEdit: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    FtpUserEdit: TEdit;
    FtpPassEdit: TEdit;
    PassiveCheckBox: TCheckBox;
    BinaryCheckBox: TCheckBox;
    Label7: TLabel;
    FtpFileNameEdit: TEdit;
    BottomPanel: TPanel;
    CountLabel: TLabel;
    MPBar: TMultiProgressBar;
    PartCountLabel: TLabel;
    PartCountEdit: TEdit;
    AbortButton: TButton;
    DownloadButton: TButton;
    ResumeButton: TButton;
    PauseButton: TButton;
    ClearButton: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure DownloadButtonClick(Sender: TObject);
    procedure MPFtpDisplay(Sender: TObject; const Msg: String);
    procedure MPFtpProgressAddSegment(Sender: TObject; StartOffset, ASpan,
      InitPos: Int64);
    procedure MPFtpProgressSetPosition(Sender: TObject; Index: Integer;
      Position: Int64);
    procedure MPFtpShowStats(Sender: TObject);
    procedure MPFtpRequestDone(Sender: TObject; ErrorCode: Integer;
      const Reason: String);
    procedure ClearButtonClick(Sender: TObject);
    procedure PauseButtonClick(Sender: TObject);
    procedure ResumeButtonClick(Sender: TObject);
  private
    FIniFileName : String;
    FInitialized : Boolean;
  public
    procedure Display(Msg : String);
    property IniFileName : String read FIniFileName write FIniFileName;
  end;

var
  MultipartFtpDownloadForm: TMultipartFtpDownloadForm;

implementation

{$R *.DFM}

const
    SectionWindow      = 'Window';   // Must be unique for each window
    KeyTop             = 'Top';
    KeyLeft            = 'Left';
    KeyWidth           = 'Width';
    KeyHeight          = 'Height';
    SectionData        = 'Data';
    KeyServer          = 'Server';
    KeyPort            = 'Port';
    KeyUserCode        = 'UserCode';
    KeyPassword        = 'Password';
    KeyDir             = 'Dir';
    KeyFile            = 'File';
    KeyLocalPath       = 'LocalPath';
    KeyPassive         = 'Passive';
    KeyBinary          = 'Binary';
    KeyPartCount       = 'PartCount';


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.FormCreate(Sender: TObject);
begin
    FIniFileName := LowerCase(ExtractFileName(Application.ExeName));
    FIniFileName := Copy(FIniFileName, 1, Length(FIniFileName) - 3) + 'ini';
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.FormShow(Sender: TObject);
var
    IniFile : TIniFile;
begin
    if not FInitialized then begin
        FInitialized := TRUE;

        IniFile      := TIniFile.Create(FIniFileName);
        Width        := IniFile.ReadInteger(SectionWindow, KeyWidth,  Width);
        Height       := IniFile.ReadInteger(SectionWindow, KeyHeight, Height);
        Top          := IniFile.ReadInteger(SectionWindow, KeyTop,
                                            (Screen.Height - Height) div 2);
        Left         := IniFile.ReadInteger(SectionWindow, KeyLeft,
                                            (Screen.Width  - Width)  div 2);
        FtpServerEdit.Text      := IniFile.ReadString(
                                       SectionData, KeyServer,
                                       'ftp.borland.com');
        FtpPortEdit.Text        := IniFile.ReadString(
                                       SectionData, KeyPort,
                                       'ftp');
        FtpUserEdit.Text        := IniFile.ReadString(
                                       SectionData, KeyUserCode,
                                       'anonymous');
        FtpPassEdit.Text        := IniFile.ReadString(
                                       SectionData, KeyPassword,
                                       'guest@unknown');
        FtpDirEdit.Text         := IniFile.ReadString(
                                       SectionData, KeyDir,
                                       '/pub/delphi/techpubs/delphi6');
        FtpFileNameEdit.Text    := IniFile.ReadString(
                                       SectionData, KeyFile,
                                       'UsingWebSnap.pdf');
        LocalFilePathEdit.Text  := IniFile.ReadString(
                                       SectionData, KeyLocalPath,
                                       'c:\temp\UsingWebSnap.pdf');
        PartCountEdit.Text      := IniFile.ReadString(
                                       SectionData, KeyPartCount,
                                       '10');
        PassiveCheckBox.Checked := IniFile.ReadBool(SectionData,
                                                    KeyPassive, TRUE);
        BinaryCheckBox.Checked  := IniFile.ReadBool(SectionData,
                                                    KeyBinary, TRUE);
        IniFile.Destroy;
        DisplayMemo.Clear;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
    IniFile : TIniFile;
begin
    IniFile := TIniFile.Create(FIniFileName);
    IniFile.WriteInteger(SectionWindow, KeyTop,         Top);
    IniFile.WriteInteger(SectionWindow, KeyLeft,        Left);
    IniFile.WriteInteger(SectionWindow, KeyWidth,       Width);
    IniFile.WriteInteger(SectionWindow, KeyHeight,      Height);
    IniFile.WriteString(SectionData, KeyServer,    FtpServerEdit.Text);
    IniFile.WriteString(SectionData, KeyPort,      FtpPortEdit.Text);
    IniFile.WriteString(SectionData, KeyUserCode,  FtpUserEdit.Text);
    IniFile.WriteString(SectionData, KeyPassword,  FtpPassEdit.Text);
    IniFile.WriteString(SectionData, KeyDir,       FtpDirEdit.Text);
    IniFile.WriteString(SectionData, KeyFile,      FtpFileNameEdit.Text);
    IniFile.WriteString(SectionData, KeyLocalPath, LocalFilePathEdit.Text);
    IniFile.WriteString(SectionData, KeyPartCount, PartCountEdit.Text);
    IniFile.WriteBool(SectionData, KeyPassive, PassiveCheckBox.Checked);
    IniFile.WriteBool(SectionData, KeyBinary,  BinaryCheckBox.Checked);
    IniFile.Destroy;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.Display(Msg : String);
begin
    DisplayMemo.Lines.BeginUpdate;
    try
        if DisplayMemo.Lines.Count > 1000 then begin
            while DisplayMemo.Lines.Count > 1000 do
                DisplayMemo.Lines.Delete(0);
        end;
        DisplayMemo.Lines.Add(Msg);
    finally
        DisplayMemo.Lines.EndUpdate;
        SendMessage(DisplayMemo.Handle, EM_SCROLLCARET, 0, 0);
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.DownloadButtonClick(Sender: TObject);
begin
    MPBar.Clear;
    MPFtp.Server        := Trim(FtpServerEdit.Text);
    MPFtp.Port          := Trim(FtpPortEdit.Text);
    MPFtp.User          := Trim(FtpUserEdit.Text);
    MPFtp.Pass          := Trim(FtpPassEdit.Text);
    MPFtp.Dir           := Trim(FtpDirEdit.Text);
    MPFtp.FileName      := Trim(FtpFileNameEdit.Text);
    MPFtp.Passive       := PassiveCheckBox.Checked;
    MPFtp.Binary        := BinaryCheckBox.Checked;
    MPFtp.StateFileName := Trim(LocalFilePathEdit.Text) + '.Status';
    MPFtp.PartCount     := StrToIntDef(Trim(PartCountEdit.Text), 0);
    MPFtp.FileStream    := TFileStream.Create(Trim(LocalFilePathEdit.Text), fmCreate);
    try
        MPFtp.Start;
    except
        on E:Exception do begin
            MPFtp.FileStream.Free;
            MPFtp.FileStream := nil;
            Display('Unable to start download. ' +
                    E.ClassName + ': ' + E.Message);
        end;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.MPFtpDisplay(
    Sender: TObject;
    const Msg: String);
begin
    Display(Msg);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.MPFtpProgressAddSegment(
    Sender                      : TObject;
    StartOffset, ASpan, InitPos : Int64);
begin
    MPBar.AddSegment(StartOffset, ASpan, InitPos, clBlue);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.MPFtpProgressSetPosition(
    Sender   : TObject;
    Index    : Integer;
    Position : Int64);
begin
    MPBar.SetPosition(Index, Position);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.MPFtpShowStats(
    Sender: TObject);
begin
    CountLabel.Caption :=
            'Bytes: ' + IntToStr(MPFtp.TotalCount) +
             '   %: ' + Format('%3.0f', [MPFtp.PercentDone]) +
          '   Kbps: ' + Format('%6.2f', [MPFtp.CurSpeed]) +
        '  Elapsed: ' + FormatDateTime('hh:nn:ss', MPFtp.ElapsedTime);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.MPFtpRequestDone(
    Sender       : TObject;
    ErrorCode    : Integer;
    const Reason : String);
begin
    MPFtp.FileStream.Free;
    MPFtp.FileStream := nil;
    if ErrorCode = 200 then
        Display('Finished')
    else
        Display('Finished, error #' + IntToStr(ErrorCode) + ' ' + Reason);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.ClearButtonClick(Sender: TObject);
begin
    DisplayMemo.Clear;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.PauseButtonClick(Sender: TObject);
begin
    MPFtp.Pause;
    MPFtp.FileStream.Free;
    MPFtp.FileStream := nil;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TMultipartFtpDownloadForm.ResumeButtonClick(Sender: TObject);
begin
    MPBar.Clear;
    MPFtp.Server        := Trim(FtpServerEdit.Text);
    MPFtp.Port          := Trim(FtpPortEdit.Text);
    MPFtp.User          := Trim(FtpUserEdit.Text);
    MPFtp.Pass          := Trim(FtpPassEdit.Text);
    MPFtp.Dir           := Trim(FtpDirEdit.Text);
    MPFtp.FileName      := Trim(FtpFileNameEdit.Text);
    MPFtp.Passive       := PassiveCheckBox.Checked;
    MPFtp.Binary        := BinaryCheckBox.Checked;
    MPFtp.StateFileName := Trim(LocalFilePathEdit.Text) + '.Status';
    MPFtp.FileStream    := TFileStream.Create(Trim(LocalFilePathEdit.Text), fmOpenWrite);
    try
        MPFtp.Resume;
    except
        on E:Exception do begin
            MPFtp.FileStream.Free;
            MPFtp.FileStream := nil;
            Display('Unable to resume download. ' +
                    E.ClassName + ': ' + E.Message);
        end;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

end.
